diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -2695,79 +4589,528 @@
     // DIV register emulation
     gbDivTicks -= clockTicks;
     while(gbDivTicks <= 0) {
-      register_DIV++;
+      gbMemory[0xff04] = ++register_DIV;
       gbDivTicks += GBDIV_CLOCK_TICKS;
     }
 
     if(register_LCDC & 0x80) {
       // LCD stuff
+
       gbLcdTicks -= clockTicks;
-      if(gbLcdMode == 1) {
-        // during V-BLANK,we need to increment LY at the same rate!
-        gbLcdLYIncrementTicks -= clockTicks;
-        while(gbLcdLYIncrementTicks <= 0) {
+      gbLcdTicksDelayed -= clockTicks;
+      gbLcdLYIncrementTicks -= clockTicks;
+      gbLcdLYIncrementTicksDelayed -= clockTicks;
+
+
+      // our counters are off, see what we need to do
+
+      // This looks (and kinda is) complicated, however this
+      // is the only way I found to emulate properly the way
+      // the real hardware operates...
+      while(((gbLcdTicks <= 0) && (gbLCDChangeHappened == false)) ||
+            ((gbLcdTicksDelayed <= 0) && (gbLCDChangeHappened == true)) ||
+            ((gbLcdLYIncrementTicks <= 0) && (gbLYChangeHappened == false)) ||
+            ((gbLcdLYIncrementTicksDelayed<=0) && (gbLYChangeHappened == true)))
+      {
+
+        if ((gbLcdLYIncrementTicks <= 0) && (!gbLYChangeHappened))
+        {
+          gbLYChangeHappened = true;
+          gbMemory[0xff44] = register_LY = (register_LY + 1) % 154;
+
+          if (register_LY == 0x91)
+          {
+           /* if (IFF & 0x80)
+              gbScreenOn = !gbScreenOn;
+            else*/ if (register_LCDC & 0x80)
+              gbScreenOn = true;
+          }
+
           gbLcdLYIncrementTicks += GBLY_INCREMENT_CLOCK_TICKS;
 
-          if(register_LY < 153) {
-            register_LY++;
-            
-            gbCompareLYToLYC();
-            
-            if(register_LY >= 153)
-              gbLcdLYIncrementTicks = 6;
-          } else {
-            register_LY = 0x00;
-            // reset the window line
-            gbWindowLine = -1;
-            gbLcdLYIncrementTicks = GBLY_INCREMENT_CLOCK_TICKS * 2;
-            gbCompareLYToLYC();
+          if (gbLcdMode == 1)
+          {
+
+            if(register_LY == 153)
+              gbLcdLYIncrementTicks -= GBLY_INCREMENT_CLOCK_TICKS - gbLine99Ticks;
+            else if(register_LY == 0)
+              gbLcdLYIncrementTicks += GBLY_INCREMENT_CLOCK_TICKS - gbLine99Ticks;
+          }
+
+          // GB only 'bug' : Halt state is broken one tick before LY==LYC interrupt
+          // is reflected in the registers.
+          if ((gbHardware & 5) && (IFF & 0x80) && (register_LY == register_LYC)
+              && (register_STAT & 0x40) && (register_LY != 0))
+          {
+            if (!((gbLcdModeDelayed != 1) && (register_LY==0)))
+            {
+              gbInt48Signal &= ~9;
+              gbCompareLYToLYC();
+              gbLYChangeHappened = false;
+              gbMemory[0xff41] = register_STAT;
+              gbMemory[0xff0f] = register_IF;
+            }
+
+            gbLcdLYIncrementTicksDelayed += GBLY_INCREMENT_CLOCK_TICKS - gbLine99Ticks+1;
           }
         }
-      }
+
+
+        if ((gbLcdTicks <= 0) && (!gbLCDChangeHappened))
+        {
+          gbLCDChangeHappened = true;
+
+          switch(gbLcdMode)
+          {
+            case 0:
+            {
+              // H-Blank              
+              // check if we reached the V-Blank period       
+              if(register_LY == 144) {
+                // Yes, V-Blank
+                // set the LY increment counter
+                if (gbHardware & 0x5)
+                {
+                  register_IF |= 1; // V-Blank interrupt
+                }
+
+                  gbInt48Signal &= ~6;
+                  if(register_STAT & 0x10)
+                  {
+                    // send LCD interrupt only if no interrupt 48h signal...
+                    if ((!(gbInt48Signal & 1)) && ((!(gbInt48Signal & 8)) || (gbHardware & 0x0a)))
+                    {
+                      register_IF |=2;
+                      gbInterruptLaunched |= 2;
+                      if (gbHardware & 0xa)
+                        gbInterruptWait = 1;
+                    }
+                    gbInt48Signal |= 2;
+                  }
+                  gbInt48Signal &= ~1;
+
+                gbLcdTicks += GBLCD_MODE_1_CLOCK_TICKS;
+                gbLcdMode = 1;
+
+              } else {
+                // go the the OAM being accessed mode
+                gbLcdTicks += GBLCD_MODE_2_CLOCK_TICKS;
+                gbLcdMode = 2;
+
+                gbInt48Signal &= ~6;
+                if(register_STAT & 0x20)
+                {
+                  // send LCD interrupt only if no interrupt 48h signal...
+                  if (!gbInt48Signal)
+                  {
+                    register_IF |= 2;
+                    gbInterruptLaunched |= 2;
+                  }
+                  gbInt48Signal |= 4;
+                }
+                gbInt48Signal &= ~1;
+              }
+            }
+            break;
+            case 1:
+            {
+              // V-Blank
+              // next mode is OAM being accessed mode
+              gbInt48Signal &= ~5;
+              if(register_STAT & 0x20)
+              {
+                // send LCD interrupt only if no interrupt 48h signal...
+                if (!gbInt48Signal)
+                {
+                  register_IF |= 2;
+                  gbInterruptLaunched |= 2;
+                  if ((gbHardware & 0xa) && (IFF & 0x80))
+                    gbInterruptWait = 1;
+                }
+                gbInt48Signal |= 4;
+              }
+              gbInt48Signal &= ~2;
+
+              gbLcdTicks += GBLCD_MODE_2_CLOCK_TICKS;
+
+              gbLcdMode = 2;
+              register_LY = 0x00;
+
+            }
+            break;
+            case 2:
+            {
+
+              // OAM being accessed mode
+              // next mode is OAM and VRAM in use
+              if ((gbScreenOn) && (register_LCDC & 0x80))
+              {
+                gbDrawSprites(false);
+                // Used to add a one tick delay when a window line is drawn.
+                //(fixes a part of Carmaggedon problem)
+                if((register_LCDC & 0x01 || gbCgbMode) && (register_LCDC & 0x20) &&
+                   (gbWindowLine != -2)) {
+
+                  int inUseRegister_WY = 0;
+                  int tempgbWindowLine = gbWindowLine;
+
+                  if ((tempgbWindowLine == -1) || (tempgbWindowLine>144))
+                  {
+                    inUseRegister_WY = oldRegister_WY;
+                    if (register_LY>oldRegister_WY)
+                    tempgbWindowLine = 146;
+                  }
+ 
+                  int wy = inUseRegister_WY;
       
-      // our counter is off, see what we need to do
-      while(gbLcdTicks <= 0) {
-        int framesToSkip = systemFrameSkip;
-        if(speedup)
-          framesToSkip = 9; // try 6 FPS during speedup
-        switch(gbLcdMode) {
-        case 0:
-          // H-Blank
-          register_LY++;
+                  if(register_LY >= inUseRegister_WY) {
 
-          gbCompareLYToLYC();
+                    if (tempgbWindowLine == -1)
+                      tempgbWindowLine = 0;
+
+                    int wx = register_WX;
+                    wx -= 7;
+                    if (wx<0)
+                        wx = 0;
+        
+                    if((wx <= 159) && (tempgbWindowLine <= 143))
+                      for (int i = wx; i<300; i++)
+                        if (gbSpeed)
+                          gbSpritesTicks[i]+=3;
+                        else
+                          gbSpritesTicks[i]+=1;
+                  }
+                }
+              }
+
+              gbInt48Signal &= ~7;
+
+              gbLcdTicks += GBLCD_MODE_3_CLOCK_TICKS+gbSpritesTicks[299];
+              gbLcdMode = 3;
+            }
+            break;
+            case 3:
+            {
+              // OAM and VRAM in use
+              // next mode is H-Blank
+
+
+              gbInt48Signal &= ~7;
+              if(register_STAT & 0x08)
+              {
+                // send LCD interrupt only if no interrupt 48h signal...
+                if (!(gbInt48Signal & 8))
+                {
+                  register_IF |= 2;
+                if ((gbHardware & 0xa) && (IFF & 0x80))
+                  gbInterruptWait = 1;
+                }
+                gbInt48Signal |= 1;
+              }
+
+              gbLcdTicks += GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299];
+
+              gbLcdMode = 0;
+
+              // No HDMA during HALT !
+              if(gbHdmaOn && (!(IFF & 0x80) || (register_IE & register_IF & 0x1f))) {
+                gbDoHdma();
+              }
+
+            }
+            break;
+          }
+        }
+
+
+        if ((gbLcdTicksDelayed <= 0) && (gbLCDChangeHappened)) {
+          int framesToSkip = systemFrameSkip;
+          if(speedup)
+            framesToSkip = 9; // try 6 FPS during speedup
+          //gbLcdTicksDelayed = gbLcdTicks+1;
+          gbLCDChangeHappened = false;
+          switch(gbLcdModeDelayed) {
+            case 0:
+            {
+              // H-Blank 
           
-          // check if we reached the V-Blank period       
-          if(register_LY == 144) {
-            // Yes, V-Blank
-            // set the LY increment counter
-            gbLcdLYIncrementTicks = gbLcdTicks + GBLY_INCREMENT_CLOCK_TICKS;
-            gbLcdTicks += GBLCD_MODE_1_CLOCK_TICKS;
-            gbLcdMode = 1;
-            if(register_LCDC & 0x80) {
-              gbInterrupt |= 1; // V-Blank interrupt
-              gbInterruptWait = 6;
-              if(register_STAT & 0x10)
-                gbInterrupt |= 2;
+              memset(gbSCYLine,gbSCYLine[299],sizeof(gbSCYLine));
+              memset(gbSCXLine,gbSCXLine[299],sizeof(gbSCXLine));
+              memset(gbBgpLine,gbBgpLine[299],sizeof(gbBgpLine));
+              memset(gbObp0Line,gbObp0Line[299],sizeof(gbObp0Line));
+              memset(gbObp1Line,gbObp1Line[299],sizeof(gbObp1Line));
+              memset(gbSpritesTicks,gbSpritesTicks[299],sizeof(gbSpritesTicks));
+
+              if (gbWindowLine <0)
+                oldRegister_WY = register_WY;
+              // check if we reached the V-Blank period       
+              if(register_LY == 144) {
+                // Yes, V-Blank
+                // set the LY increment counter
+
+                if(register_LCDC & 0x80) {
+                    if (gbHardware & 0xa)
+                    {
+                  
+                    register_IF |= 1; // V-Blank interrupt
+                    gbInterruptLaunched |=1;
+                    }
+                  
+
+                }
+            
+                gbLcdTicksDelayed += GBLCD_MODE_1_CLOCK_TICKS;
+                gbLcdModeDelayed = 1;
+
+                gbFrameCount++;
+                systemFrame();
+
+                if((gbFrameCount % 10) == 0)
+                  system10Frames(60);
+
+                if(gbFrameCount >= 60) {
+                  u32 currentTime = systemGetClock();
+                  if(currentTime != gbLastTime)
+                    systemShowSpeed(100000/(currentTime - gbLastTime));
+                  else
+                    systemShowSpeed(0);
+                  gbLastTime = currentTime;
+                  gbFrameCount = 0;       
+                }
+
+                if(systemReadJoypads()) {
+                  // read joystick
+                  if(gbSgbMode && gbSgbMultiplayer) {
+                    if(gbSgbFourPlayers) {
+                      gbJoymask[0] = systemReadJoypad(0);
+                      gbJoymask[1] = systemReadJoypad(1);
+                      gbJoymask[2] = systemReadJoypad(2);
+                      gbJoymask[3] = systemReadJoypad(3);
+                    } else {
+                      gbJoymask[0] = systemReadJoypad(0);
+                      gbJoymask[1] = systemReadJoypad(1);
+                    }
+                  } else {
+                    gbJoymask[0] = systemReadJoypad(-1);
+                  }             
+                }
+                int newmask = gbJoymask[0] & 255;
+
+                if(gbRomType == 0x22) {
+                  systemUpdateMotionSensor();
+                }
+            
+                if(newmask)
+                {
+                  gbMemory[0xff0f] |= 16;
+                }
+
+
+                newmask = (gbJoymask[0] >> 10);
+            
+                speedup = (newmask & 1) ? true : false;
+                gbCapture = (newmask & 2) ? true : false;
+
+                if(gbCapture && !gbCapturePrevious) {
+                  gbCaptureNumber++;
+                  systemScreenCapture(gbCaptureNumber);
+                }
+                gbCapturePrevious = gbCapture;
+            
+          if(gbFrameSkipCount >= framesToSkip) {
+
+            if(!gbSgbMask)
+            {
+              if (gbBorderOn)
+                gbSgbRenderBorder();
+              //if (gbScreenOn)
+                systemDrawScreen();
             }
+            gbFrameSkipCount = 0;
+          } else
+             gbFrameSkipCount++;
 
-            gbFrameCount++;
+              } else {
+                // go the the OAM being accessed mode
+                gbLcdTicksDelayed += GBLCD_MODE_2_CLOCK_TICKS;
+                gbLcdModeDelayed = 2;
+                gbInt48Signal &= ~3;
+              }
+            }
+            break;
+            case 1:
+            {
+              // V-Blank
+              // next mode is OAM being accessed mode
 
-            systemFrame();
+             // gbScreenOn = true;
 
-            if((gbFrameCount % 10) == 0)
-              system10Frames(60);
+              oldRegister_WY = register_WY;
 
-            if(gbFrameCount >= 60) {
-              u32 currentTime = systemGetClock();
-              if(currentTime != gbLastTime)
-                systemShowSpeed(100000/(currentTime - gbLastTime));
-              else
-                systemShowSpeed(0);
-              gbLastTime = currentTime;
-              gbFrameCount = 0;       
+              gbLcdTicksDelayed += GBLCD_MODE_2_CLOCK_TICKS;
+              gbLcdModeDelayed = 2;
+
+              // reset the window line
+              gbWindowLine = -1;
+            }
+            break;
+            case 2:
+            {
+              // OAM being accessed mode
+              // next mode is OAM and VRAM in use
+              gbLcdTicksDelayed += GBLCD_MODE_3_CLOCK_TICKS+gbSpritesTicks[299];
+              gbLcdModeDelayed = 3;
+            }
+            break;
+            case 3:
+            {
+
+              // OAM and VRAM in use
+              // next mode is H-Blank
+              if((register_LY < 144) && (register_LCDC & 0x80) && gbScreenOn) {
+                if(!gbSgbMask) {
+                  if(gbFrameSkipCount >= framesToSkip) {
+                    if (!gbBlackScreen)
+                    {
+                      gbRenderLine();
+                      gbDrawSprites(true);
+                    }
+                    else if (gbBlackScreen)
+                    {
+                      u16 color = gbColorOption ? gbColorFilter[0] : 0;
+                      if (!gbCgbMode)
+                      color = gbColorOption ? gbColorFilter[gbPalette[3] & 0x7FFF] :
+                        gbPalette[3] & 0x7FFF;
+                      for(int i = 0; i < 160; i++)
+                      {
+                        gbLineMix[i] = color;
+                        gbLineBuffer[i] = 0;
+                      }
+                    }
+                    gbDrawLine();
+                  }
+                }
+              }
+              gbLcdTicksDelayed += GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299];
+              gbLcdModeDelayed = 0;
+            }
+            break;
+          }
+        }
+
+        if ((gbLcdLYIncrementTicksDelayed <= 0) && (gbLYChangeHappened == true))
+        {
+
+          gbLYChangeHappened = false;
+
+          if (!((gbLcdMode != 1) && (register_LY==0)))
+          {
+            {
+              gbInt48Signal &= ~8;
+              gbCompareLYToLYC();
+              if ((gbInt48Signal == 8) && (!((register_LY == 0) && (gbHardware & 1))))
+                gbInterruptLaunched |= 2;
+              if ((gbHardware & (gbSpeed ? 8 : 2)) && (register_LY==0) && ((register_STAT & 0x44) == 0x44) && (gbLcdLYIncrementTicksDelayed==0))
+              {
+                 gbInterruptWait = 1;
+
+              }
+            }
+          }
+          gbLcdLYIncrementTicksDelayed += GBLY_INCREMENT_CLOCK_TICKS;
+
+          if (gbLcdModeDelayed == 1)
+          {
+
+            if(register_LY == 153)
+              gbLcdLYIncrementTicksDelayed -= GBLY_INCREMENT_CLOCK_TICKS - gbLine99Ticks;
+            else if(register_LY == 0)
+              gbLcdLYIncrementTicksDelayed += GBLY_INCREMENT_CLOCK_TICKS - gbLine99Ticks;
+          }
+          gbMemory[0xff0f] = register_IF;
+          gbMemory[0xff41] = register_STAT;
+        }
+      }
+      gbMemory[0xff0f] = register_IF;
+      gbMemory[0xff41] = register_STAT = (register_STAT & 0xfc) | gbLcdModeDelayed;
+    }
+    else
+    {
+
+      // Used to update the screen with white lines when it's off.
+      // (it looks strange, but it's kinda accurate :p)
+      // You can try the Mario Demo Vx.x for exemple
+      // (check the bottom 2 lines while moving)
+     if (!gbWhiteScreen)
+      {
+        gbScreenTicks -= clockTicks;
+        gbLcdLYIncrementTicks -= clockTicks;
+        while (gbLcdLYIncrementTicks <=0)
+        {
+          register_LY = ((register_LY+1)%154);
+          gbLcdLYIncrementTicks+=GBLY_INCREMENT_CLOCK_TICKS; 
+        }
+        if (gbScreenTicks <= 0)
+        {
+          gbWhiteScreen = 1;
+          u8 register_LYLcdOff = ((register_LY+154)%154);
+          for (register_LY=0;register_LY <=  0x90;register_LY++)
+          {
+            u16 color = gbColorOption ? gbColorFilter[0x7FFF] :
+                        0x7FFF;
+            if (!gbCgbMode)
+            color = gbColorOption ? gbColorFilter[gbPalette[0] & 0x7FFF] :
+                        gbPalette[0] & 0x7FFF;
+            for(int i = 0; i < 160; i++)
+            {
+              gbLineMix[i] = color;
+              gbLineBuffer[i] = 0;
             }
+            gbDrawLine();
+          }
+          register_LY = register_LYLcdOff;
+        }
+      }
+        
+      if (gbWhiteScreen)
+      {
+        gbLcdLYIncrementTicks -= clockTicks;
 
+        while (gbLcdLYIncrementTicks <=0)
+        {
+          register_LY = ((register_LY+1)%154);
+          gbLcdLYIncrementTicks+=GBLY_INCREMENT_CLOCK_TICKS; 
+          if (register_LY<144)
+          {
+
+            u16 color = gbColorOption ? gbColorFilter[0x7FFF] :
+                        0x7FFF;
+            if (!gbCgbMode)
+            color = gbColorOption ? gbColorFilter[gbPalette[0] & 0x7FFF] :
+                        gbPalette[0] & 0x7FFF;
+            for(int i = 0; i < 160; i++)
+            {
+              gbLineMix[i] = color;
+              gbLineBuffer[i] = 0;
+            }
+            gbDrawLine();
+          }
+          else if ((register_LY==144) && (!systemFrameSkip))
+          {
+            int framesToSkip = systemFrameSkip;
+            if(speedup)
+              framesToSkip = 9; // try 6 FPS during speedup
+            if((gbFrameSkipCount >= framesToSkip) || (gbWhiteScreen == 1)) {
+              gbWhiteScreen = 2;
+
+            if(!gbSgbMask)
+            {
+              if (gbBorderOn)
+                gbSgbRenderBorder();
+                  //if (gbScreenOn)
+                systemDrawScreen();
+            }
+            }
             if(systemReadJoypads()) {
               // read joystick
               if(gbSgbMode && gbSgbMultiplayer) {
@@ -2784,198 +5127,29 @@
                 gbJoymask[0] = systemReadJoypad(-1);
               }             
             }
-            int newmask = gbJoymask[0] & 255;
+            gbFrameCount++;
 
-            if(gbRom[0x147] == 0x22) {
-              systemUpdateMotionSensor();
-            }
-            
-            if(newmask) {
-              gbInterrupt |= 16;
-            }
+            systemFrame();
 
-            newmask = (gbJoymask[0] >> 10);
-            
-            speedup = (newmask & 1) ? true : false;
-            gbCapture = (newmask & 2) ? true : false;
+            if((gbFrameCount % 10) == 0)
+              system10Frames(60);
 
-            if(gbCapture && !gbCapturePrevious) {
-              gbCaptureNumber++;
-              systemScreenCapture(gbCaptureNumber);
-            }
-            gbCapturePrevious = gbCapture;
-            
-            if(gbFrameSkipCount >= framesToSkip) {
-              systemDrawScreen();
-              gbFrameSkipCount = 0;
-            } else
-              gbFrameSkipCount++;
-          } else {
-            // go the the OAM being accessed mode
-            gbLcdTicks += GBLCD_MODE_2_CLOCK_TICKS;
-            gbLcdMode = 2;
-
-            // only one LCD interrupt per line. may need to generalize...
-            if(!(register_STAT & 0x40) ||
-               (register_LY != register_LYC)) {
-              if((register_STAT & 0x28) == 0x20)
-                gbInterrupt |= 2;
-            }
-          }
-          break;
-        case 1:
-          // V-Blank
-          // next mode is OAM being accessed mode
-          gbLcdTicks += GBLCD_MODE_2_CLOCK_TICKS;
-          gbLcdMode = 2;
-          if(!(register_STAT & 0x40) ||
-             (register_LY != register_LYC)) {
-            if((register_STAT & 0x28) == 0x20)
-              gbInterrupt |= 2;
-          }
-          break;
-        case 2:
-          // OAM being accessed mode
-          
-          // next mode is OAM and VRAM in use
-          gbLcdTicks += GBLCD_MODE_3_CLOCK_TICKS;
-          gbLcdMode = 3;
-          break;
-        case 3:
-          // OAM and VRAM in use
-          // next mode is H-Blank
-          if(register_LY < 144) {
-            if(!gbSgbMask) {
-              if(gbFrameSkipCount >= framesToSkip) {
-                gbRenderLine();
-                gbDrawSprites();
-                
-                switch(systemColorDepth) {
-                case 16:
-                  {
-                    u16 * dest = (u16 *)pix +
-                      (gbBorderLineSkip+2) * (register_LY + gbBorderRowSkip+1)
-                      + gbBorderColumnSkip;
-                    for(int x = 0; x < 160; ) {
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                      *dest++ = systemColorMap16[gbLineMix[x++]];
-                    }
-                    if(gbBorderOn)
-                      dest += gbBorderColumnSkip;
-                    *dest++ = 0; // for filters that read one pixel more
-                  }
-                  break;
-                case 24:
-                  {
-                    u8 *dest = (u8 *)pix +
-                      3*(gbBorderLineSkip * (register_LY + gbBorderRowSkip) +
-                         gbBorderColumnSkip);
-                    for(int x = 0; x < 160;) {
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                      *((u32 *)dest) = systemColorMap32[gbLineMix[x++]];
-                      dest+= 3;
-                    }
-                  }
-                  break;
-                case 32:
-                  {
-                    u32 * dest = (u32 *)pix +
-                      (gbBorderLineSkip+1) * (register_LY + gbBorderRowSkip+1)
-                      + gbBorderColumnSkip;
-                    for(int x = 0; x < 160;) {
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                      *dest++ = systemColorMap32[gbLineMix[x++]];
-                    }
-                  }
-                  break;
-                }
-              }
+            if(gbFrameCount >= 60) {
+              u32 currentTime = systemGetClock();
+              if(currentTime != gbLastTime)
+                systemShowSpeed(100000/(currentTime - gbLastTime));
+              else
+                systemShowSpeed(0);
+              gbLastTime = currentTime;
+              gbFrameCount = 0; 
             }
           }
-          gbLcdTicks += GBLCD_MODE_0_CLOCK_TICKS;
-          gbLcdMode = 0;
-          // only one LCD interrupt per line. may need to generalize...
-          if(!(register_STAT & 0x40) ||
-             (register_LY != register_LYC)) {
-            if(register_STAT & 0x08)
-              gbInterrupt |= 2;
-          }
-          if(gbHdmaOn) {
-            gbDoHdma();
-          }
-          break;
         }
-        // mark the correct lcd mode on STAT register
-        register_STAT = (register_STAT & 0xfc) | gbLcdMode;
       }
     }
 
+    gbMemory[0xff41] = register_STAT;
+
     // serial emulation
     if(gbSerialOn) {
 #ifdef LINK_EMULATION
@@ -2992,7 +5166,7 @@
               gbMemory[0xff01] = 0xff;
               gbMemory[0xff02] &= 0x7f;
               gbSerialOn = 0;
-              gbInterrupt |= 8;
+              gbMemory[0xff0f] = register_IF |= 8;
               gbSerialTicks = 0;
             }
           }
@@ -3018,7 +5192,7 @@
               gbSerialTicks = 0;
               gbMemory[0xff02] &= 0x7f;
               gbSerialOn = 0;
-              gbInterrupt |= 8;
+              gbMemory[0xff0f] = register_IF |= 8;
               gbSerialBits  = 0;
             } else
               gbSerialTicks += GBSERIAL_CLOCK_TICKS;
@@ -3029,27 +5203,43 @@
 #endif
     }
     
+
+    soundTicks -= clockTicks;
+
+    while(soundTicks < 0) {
+      soundTicks += SOUND_CLOCK_TICKS;
+
+      gbSoundTick();
+    }
+
+
     // timer emulation
+
     if(gbTimerOn) {
-      gbTimerTicks -= clockTicks;
-      
+      gbTimerTicks= ((gbInternalTimer) & gbTimerMask[gbTimerMode])+1-clockTicks;
+
       while(gbTimerTicks <= 0) {
         register_TIMA++;
-        
-        if(register_TIMA == 0) {
-          // timer overflow!
-            
+        // timer overflow!
+        if((register_TIMA & 0xff) == 0) {
           // reload timer modulo
           register_TIMA = register_TMA;
-            
           // flag interrupt
-          gbInterrupt |= 4;
+          gbMemory[0xff0f] = register_IF |= 4;
         }
-          
         gbTimerTicks += gbTimerClockTicks;
       }
+      gbTimerOnChange = false;
+      gbTimerModeChange = false;
+
+      gbMemory[0xff05] = register_TIMA;
+
     }
 
+    gbInternalTimer -= clockTicks;
+    while (gbInternalTimer<0)
+      gbInternalTimer+=0x100;
+
     /*
     if(soundOffFlag) {
       if(synchronize && !speedup) {
